math.randomseed(1000)

local previousPlayerLevel = 0

function preMapRebuildCallback()
    osrs.Graphics:clearAllShapes()
end

function postMapRebuildCallback()
    createShapes()
end

function lshift(x, by)
    return x * 2 ^ by
end

function rshift(x, by)
    return math.floor(x / 2 ^ by)
end

function onKeyDown(keycode)
   if keycode == 65 then -- X
        local coord = osrs.ClientOp.coord(false)
        osrs.print(string.format("Player BUILD position: X:%i Y:%i Z:%i LEVEL:%i", coord.x, coord.y, coord.z, coord.level))
        local worldCoord = coord:asWorldCoordinate()
        osrs.print(string.format("Player BUILD TO WORLD position: X:%i Y:%i Z:%i LEVEL:%i", worldCoord.x, worldCoord.y, worldCoord.z, worldCoord.level))
        local convFineCoord = coord:asFineCoordinate()
        osrs.print(string.format("Player BUILD TO FINE position: X:%i Y:%i Z:%i LEVEL:%i\n\n", convFineCoord.x, convFineCoord.y, convFineCoord.z, convFineCoord.level))
        
        local fineCoord = osrs.ClientOp.coord(true)
        osrs.print(string.format("Player FINE position: X:%i Y:%i Z:%i LEVEL:%i", fineCoord.x, fineCoord.y, fineCoord.z, fineCoord.level))
        local fineToBuildCoord = fineCoord:asBuildCoordinate()
        osrs.print(string.format("Player FINE TO BUILD position: X:%i Y:%i Z:%i LEVEL:%i", fineToBuildCoord.x, fineToBuildCoord.y, fineToBuildCoord.z, fineToBuildCoord.level))
        local fineToWorldCoord = fineCoord:asWorldCoordinate()
        osrs.print(string.format("Player FINE TO WORLD position: X:%i Y:%i Z:%i LEVEL:%i\n\n", fineToWorldCoord.x, fineToWorldCoord.y, fineToWorldCoord.z, fineToWorldCoord.level))
   
        local worldToBuildCoord = fineToWorldCoord:asBuildCoordinate()
        osrs.print(string.format("Player WORLD TO BUILD position: X:%i Y:%i Z:%i LEVEL:%i", worldToBuildCoord.x, worldToBuildCoord.y, worldToBuildCoord.z, worldToBuildCoord.level))
        local worldToFineCoord = fineToWorldCoord:asFineCoordinate()
        osrs.print(string.format("Player WORLD TO FINE position: X:%i Y:%i Z:%i LEVEL:%i\n\n", worldToFineCoord.x, worldToFineCoord.y, worldToFineCoord.z, worldToFineCoord.level))
    
        local npcCoord = osrs.ClientOp.npc_coord(npcId, false)
        osrs.print(string.format("NPC BUILD position: X:%i Y:%i Z:%i LEVEL:%i", npcCoord.x, npcCoord.y, npcCoord.z, npcCoord.level))
        local npcWorldCoord = npcCoord:asWorldCoordinate()
        osrs.print(string.format("NPC BUILD TO WORLD position: X:%i Y:%i Z:%i LEVEL:%i", npcWorldCoord.x, npcWorldCoord.y, npcWorldCoord.z, npcWorldCoord.level))
        local npcConvFineCoord = npcCoord:asFineCoordinate()
        osrs.print(string.format("NPC BUILD TO FINE position: X:%i Y:%i Z:%i LEVEL:%i\n\n", npcConvFineCoord.x, npcConvFineCoord.y, npcConvFineCoord.z, npcConvFineCoord.level))
    
        local nfineCoord = osrs.ClientOp.npc_coord(npcId, true)
        osrs.print(string.format("NPC FINE position: X:%i Y:%i Z:%i LEVEL:%i", nfineCoord.x, nfineCoord.y, nfineCoord.z, nfineCoord.level))
        local nfineToBuildCoord = nfineCoord:asBuildCoordinate()
        osrs.print(string.format("NPC FINE TO BUILD position: X:%i Y:%i Z:%i LEVEL:%i", nfineToBuildCoord.x, nfineToBuildCoord.y, nfineToBuildCoord.z, nfineToBuildCoord.level))
        local nfineToWorldCoord = nfineCoord:asWorldCoordinate()
        osrs.print(string.format("NPC FINE TO WORLD position: X:%i Y:%i Z:%i LEVEL:%i\n\n", nfineToWorldCoord.x, nfineToWorldCoord.y, nfineToWorldCoord.z, nfineToWorldCoord.level))
    end
end

function createShapes()    
    local playerCoord = osrs.ClientOp.coord(false) -- we only want to put shapes on things on our current level

    playerShape = osrs.Shape.new(osrs.Shape.PrimitiveType.CIRCLE)
    playerShape.colour:set(255, 0, 0, 96)
    playerShape.dimensions:set(15, 15)
    osrs.Graphics:addShape(playerShape)
    
    npcId = osrs.ClientOp.getnpcbyname("Man")
    osrs.ClientOp.highlight_npc_on(npcId, osrs.ClientOp.npc_creationcycle(npcId), 6)
    npcShape = osrs.Shape.new(osrs.Shape.PrimitiveType.CIRCLE)
    npcShape.colour:set(0, 0, 255, 96)
    npcShape.dimensions:set(10, 10)
    osrs.Graphics:addShape(npcShape)
end

function startUp()
    osrs.Events:subscribe(preMapRebuildCallback, osrs.Events.ON_MAP_REBUILD_PRE)
    osrs.Events:subscribe(postMapRebuildCallback, osrs.Events.ON_MAP_REBUILD_POST)

    callbackID = osrs.Events:subscribe(onKeyDown, osrs.Events.KEY_DOWN, callbackID)

    createShapes()

    trackpos_interval = osrs.setInterval(update, 0, -1)
end

function update()
    local playerCoord = osrs.ClientOp.coord(true)
    -- rebuild our shapes once we've changed levels, similar to how we do it on map rebuild
    if previousPlayerLevel ~= playerCoord.level then
        osrs.print("Detected level change. Rebuilding shapes lists.")
        preMapRebuildCallback()
        postMapRebuildCallback()
        previousPlayerLevel = playerCoord.level
    end
    
    playerCoord.y = playerCoord.y - 192
    local x, y = osrs.Graphics:worldToScreenCoord(playerCoord)
    playerShape.position:set(x, y)

    local npcCoord = osrs.ClientOp.npc_coord(npcId, true)
    if npcCoord.x == -1 then
        npcId = osrs.ClientOp.getnpcbyname("Man")
        osrs.ClientOp.highlight_npc_on(npcId, osrs.ClientOp.npc_creationcycle(npcId), 6)
        npcCoord = osrs.ClientOp.npc_coord(npcId, true)
    end

    --npcCoord.y = npcCoord.y - 128
    local npcX, npcY = osrs.Graphics:worldToScreenCoord(npcCoord)
    npcShape.position:set(npcX, npcY)
    return true
end

startUp()